/*
 * Pause.
 */
(function($, Drupal) {
  Drupal.skillingSettings.setupPause = false;
  Drupal.behaviors.skillingPause = {
    attach: function(context, settings) {
      if (Drupal.skillingSettings.setupPause) {
        return;
      }
      Drupal.skillingSettings.setupPause = true;
      $(document).ready(function() {
        // Remove buttons that were recently used.
        $(".skilling-pause-container").each(function () {
          let buttonCounter = $(this).data("counter");
          // let stored = sessionStorage.getItem("pause-button-" + buttonCounter);
          // if (stored === "clicked") {
          //   $(this).hide();
          // }
        });
        // On page load, hide content after a pause button group,
        // if prior code hasn't hidden the button.
        $(".skilling-pause-container.btn-group").each(function () {
          if ($(this).is(":visible")) {
            $(this).nextAll().hide();
          }
        })

        /**
         * Show one group of hidden content.
         */
        $(".skilling-pause-container button.show-more").click(function() {
          if ($(this).is(":visible")) {
            // Remember that this button was pressed.
            let buttonCounter = $(this)
                .closest(".skilling-pause-container")
                .data("counter");
            // sessionStorage.setItem("pause-button-" + buttonCounter, "clicked");
            $(this).parent().hide().nextAll().each(function () {
              $(this).show();
              if ($(this).hasClass("skilling-pause-container")) {
                return false;
              }
            });
          }
        });
        /**
         * Show all hidden content.
         */
        $(".skilling-pause-container a.dropdown-item.show-all").click(function(event) {
          event.preventDefault();
          let nextButton;
          do {
            // Find a visible More button.
            nextButton = findVisibleMoreButton();
            // Found?
            if (nextButton !== null) {
              // Yes. Click it.
              $(nextButton).click();
            }
          } while (nextButton !== null);
          return false;
        });
        /**
         * Find a visible More button.
         * @returns element|null
         *   Button, or null if none found.
         */
        let findVisibleMoreButton = function () {
          let result = null;
          let buttons = $(".skilling-pause-container button.show-more");
          $(buttons).each(function () {
            if ($(this).is(":visible")) {
              result = this;
            }
          });
          return result;
        };
      });
    } // End attach.
  };
}(jQuery, Drupal));
