<?php

namespace Drupal\skilling\Plugin\HistoryItem;

use Drupal\skilling\Plugin\HistoryItemBase;

/**
 * Provides a search history event.
 *
 * @SkillingHistoryItem(
 *  id = "skilling_search_history_event",
 *  event_type_name = "search",
 *  label = @Translation("Search"),
 *  description = @Translation("A student searched for something."),
 * )
 */
class Search extends HistoryItemBase {

  /**
   * {@inheritdoc}
   */
  public function getDetailsRenderable() {
    list($text) = $this->extractDeets();
    $result = [
      '#theme' => 'history_search_deets',
      '#text' => $text,
    ];
    return $result;
  }

  /**
   * {@inheritdoc}
   */
  public function getDetailsXml() {
    list($text) = $this->prepareForXml($this->extractDeets());
    $result = '<search>' . $text . '</search>';
    return $result;
  }

  /**
   * Extract the details into separate variables.
   *
   * @return array
   *   Deets in variables.
   */
  protected function extractDeets() {
    $deets = $this->historyEventNode->get('field_details')->value;
    // Unserialize it.
    $deets = unserialize($deets);
    $text = $deets['text'];
    return [$text];
  }

}
