<?php

namespace Drupal\skilling\Plugin;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * Provides the Skilling history item plugin manager.
 */
class HistoryItemManager extends DefaultPluginManager {

  /**
   * Constructs a new SkillingCustomTagManager object.
   *
   * @param \Traversable $namespaces
   *   An object that implements \Traversable which contains the root paths
   *   keyed by the corresponding namespace to look for plugin implementations.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/HistoryItem', $namespaces, $module_handler, 'Drupal\skilling\Plugin\HistoryItemInterface', 'Drupal\skilling\Annotation\SkillingHistoryItem');

    $this->alterInfo('skilling.history_item_info');
    $this->setCacheBackend($cache_backend, 'skilling.history_item_plugins');
  }

}
