<?php

namespace Drupal\skilling\Plugin\SkillingCustomTag;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\node\Entity\Node;
use Drupal\skilling\Plugin\SkillingCustomTagBase;
use Drupal\skilling\SkillingConstants;

/**
 * Provides a code tag.
 *
 * @SkillingCustomTag(
 *  id = "skilling_code_custom_tag",
 *  tag = "code",
 *  admin_label = @Translation("Code"),
 *  description = @Translation("Shows source code to the reader."),
 *  has_close_tag = true
 * )
 */
class CodeTag extends SkillingCustomTagBase {

  use StringTranslationTrait;

  /**
   * Process content, with options.
   *
   * @param string $content
   *   Content to process.
   * @param array $options
   *   Options.
   * @param \Drupal\node\NodeInterface $nodeWithTag
   *   The node with the tag.
   *
   * @return string
   *   Rendered content.
   */
  public function processTag($content = '', array $options = NULL, Node $nodeWithTag = NULL) {
    $renderable = [
      '#theme' => 'code',
      '#content' => trim($content),
    ];
    $rendered = \Drupal::service('renderer')->render($renderable);
    return $rendered;
  }

}
