<?php
namespace Drupal\skilling;

use Drupal\skilling\Utilities as SkillingUtilities;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Language\LanguageDefault;
//use Drupal\Core\Logger\LoggerChannel;

/**
 * Service to make a SkillingUser object. There is just one instance
 * of this service (as usual), but code may need more than
 * one instance of SkillingUser.
 *
 * @package Drupal\skilling
 */
class SkillingUserFactory {

  /**
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected $entityTypeManager;

  /**
   * @var \Drupal\skilling\Utilities
   */
  protected $skillingUtilities;

  /**
   * Default language service.
   *
   * @var \Drupal\Core\Language\LanguageDefault
   */
//  protected $languageDefault;

  //  /**
//   * @var LoggerChannel
//   */
//  protected $logger;

  /**
   * SkillingUserFactory constructor.
   *
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   * @param \Drupal\skilling\Utilities $skillingUtilities
//   * @param \Drupal\Core\Logger\LoggerChannel $logger
   */
  public function __construct(
    EntityTypeManagerInterface $entity_type_manager,
    SkillingUtilities $skillingUtilities//,
//    LanguageDefault $languageDefault
  ) { //, LoggerChannel $logger) {
    $this->entityTypeManager = $entity_type_manager;
    $this->skillingUtilities = $skillingUtilities;
//    $this->languageDefault = $languageDefault;
//    $this->logger = $logger;
  }

  /**
   * Make a SkillingUser object.
   *
   * @param integer $uid User id.
   *
   * @return \Drupal\skilling\SkillingUser A SkillingUser object.
   *
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\skilling\Exception\SkillingException
   */
  public function makeSkillingUser($uid) {
    return new SkillingUser(
      $uid, $this->entityTypeManager, $this->skillingUtilities//
    //, $this->languageDefault  //, $this->logger
    );
  }

}
